import java.util.*;
import java.io.*;

//import org.jfugue.*;
public class ProfileHandler {

	/**
	 * @param args
	 */

	public static String profileName;
	public static HashMap<Double,Double> map = new HashMap<Double,Double>();
	public static ProfileHandler instance = ProfileHandler.getInstance();
	
	private ProfileHandler() {}
	
	public static ProfileHandler getInstance() {
		if (instance == null) return new ProfileHandler();
		else return instance;
	}
	
	public static void main(String[] args) throws IOException {

		// variables
        
		Scanner scan = new Scanner(System.in);
		System.out.print(" enter in your text or csv file name: ");
		profileName = scan.next();
		getInstance();
		
		if (FileIsGaussian(profileName))
			getGaussian(profileName);
		else if (FileIsDiscrete(profileName))
			getDiscrete(profileName);
			
		reader();
		holder();
		
	}// end main

	public static void reader() throws IOException {
		int count = 0;
		StringBuilder builder = new StringBuilder(count);
		Scanner scan = new Scanner(new FileInputStream(profileName));
		scan.useDelimiter(",");
		try {

			while (scan.hasNext()) {
				count++;

				builder.append(scan.nextDouble() + "\n");
			}// end while
		}// end try
		catch (Exception exception) {
		}

		finally {
			scan.close();
		}// end close

		System.out.print(builder);
		System.out.print(count);

	}// end method

	public static HashMap<Double,Double> holder() throws FileNotFoundException {
		// variables
		int count = 0;
		double key = 0;
		
		//StringBuilder key = null;
		double value = 0;
		Scanner sc = new Scanner(new File(profileName));
		sc.useDelimiter(",");
		// if count is divisible by 2
		while (sc.hasNext()) {
			double token = sc.nextDouble();
			if (count % 2 == 1) { // value, not a key
				value += token;
				map.put(key, token);
			} else { // key, not a value
			}
			count++;

		}// end while
		// verify:
				if (value != 1.0) return null;
				else return map;
	}// end method
	
	public static boolean FileIsGaussian(String profileName) throws FileNotFoundException
	{
		 Scanner scan = new Scanner(new File(profileName));
		 if (scan.next().startsWith("["))
		 { 
			 return true;
		 }
             return false;
             
	}// end FileIsGuassian
	
	public static boolean FileIsDiscrete(String profileName) throws FileNotFoundException
	{ 
		Scanner scan = new Scanner(new File(profileName));
		if(scan.next().startsWith("["))
		{ 
			return false;
		}
		    return true;
		
	}// end method is discrete
	
	public static HashMap<Double,Double> getDiscrete(String profileName) throws FileNotFoundException
	{ 
		if(!FileIsDiscrete(profileName)) return null;
		
		Scanner scan5 = new Scanner(new File(profileName));
		scan5.useDelimiter(",");
		
		HashMap<Double,Double> alist = new HashMap<Double,Double>();
		
		while (scan5.hasNextDouble()) {
		
			alist.put(scan5.nextDouble(),scan5.nextDouble());
		}
		return alist;
		
	}// end method
	
	public static Double[] getGaussian(String profileName) throws FileNotFoundException
	{ 
		if(FileIsGaussian(profileName)) return null;
		
		Scanner scan = new Scanner(new File(profileName));
		
		Double[] meanAndVariance = new Double[2];
		meanAndVariance[0] = scan.nextDouble();
		meanAndVariance[1] = scan.nextDouble();
		
		return meanAndVariance;
	}// end method
	

	
}// end class

